<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html lang="en">

<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <title>LCOV - coverage.info - proyecto/bram.vhd</title>
  <link rel="stylesheet" type="text/css" href="../gcov.css">
</head>

<body>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="title">LCOV - code coverage report</td></tr>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>

    <tr>
      <td width="100%">
        <table cellpadding=1 border=0 width="100%">
          <tr>
            <td width="10%" class="headerItem">Current view:</td>
            <td width="35%" class="headerValue"><a href="../index.html">top level</a> - <a href="index.html">proyecto</a> - bram.vhd<span style="font-size: 80%;"> (source / <a href="bram.vhd.func-sort-c.html">functions</a>)</span></td>
            <td width="5%"></td>
            <td width="15%"></td>
            <td width="10%" class="headerCovTableHead">Hit</td>
            <td width="10%" class="headerCovTableHead">Total</td>
            <td width="15%" class="headerCovTableHead">Coverage</td>
          </tr>
          <tr>
            <td class="headerItem">Test:</td>
            <td class="headerValue">coverage.info</td>
            <td></td>
            <td class="headerItem">Lines:</td>
            <td class="headerCovTableEntry">7</td>
            <td class="headerCovTableEntry">9</td>
            <td class="headerCovTableEntryMed">77.8 %</td>
          </tr>
          <tr>
            <td class="headerItem">Date:</td>
            <td class="headerValue">2023-02-09 17:19:34</td>
            <td></td>
            <td class="headerItem">Functions:</td>
            <td class="headerCovTableEntry">8</td>
            <td class="headerCovTableEntry">9</td>
            <td class="headerCovTableEntryMed">88.9 %</td>
          </tr>
          <tr><td><img src="../glass.png" width=3 height=3 alt=""></td></tr>
        </table>
      </td>
    </tr>

    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
  </table>

  <table cellpadding=0 cellspacing=0 border=0>
    <tr>
      <td><br></td>
    </tr>
    <tr>
      <td>
<pre class="sourceHeading">          Line data    Source code</pre>
<pre class="source">
<a name="1"><span class="lineNum">       1 </span><span class="lineCov">          6 : -- @author Hipólito Guzmán-Miranda</span></a>
<a name="2"><span class="lineNum">       2 </span>            : -- This code infers a BRAM when synthesized.</a>
<a name="3"><span class="lineNum">       3 </span>            : -- ``addri`` has been defined as ``unsigned`` for convenience, but could also be defined as ``std_logic_vector`` if needed</a>
<a name="4"><span class="lineNum">       4 </span>            : library ieee;</a>
<a name="5"><span class="lineNum">       5 </span>            : use ieee.std_logic_1164.all;</a>
<a name="6"><span class="lineNum">       6 </span>            : use ieee.numeric_std.all;</a>
<a name="7"><span class="lineNum">       7 </span>            : </a>
<a name="8"><span class="lineNum">       8 </span><span class="lineCov">        122 : entity bram is</span></a>
<a name="9"><span class="lineNum">       9 </span>            :   generic (</a>
<a name="10"><span class="lineNum">      10 </span>            :     DATA_WIDTH : integer := 20;  -- Width of the data bus</a>
<a name="11"><span class="lineNum">      11 </span>            :     ADDR_WIDTH : integer := 11   -- Width of the address bus</a>
<a name="12"><span class="lineNum">      12 </span>            :     );</a>
<a name="13"><span class="lineNum">      13 </span>            :   port (clk   : in  std_logic;                                 -- Clock signal, active on rising edge</a>
<a name="14"><span class="lineNum">      14 </span>            :         addri : in  unsigned (ADDR_WIDTH-1 downto 0);          -- Address</a>
<a name="15"><span class="lineNum">      15 </span>            :         datai : in  std_logic_vector (DATA_WIDTH-1 downto 0);  -- Input data</a>
<a name="16"><span class="lineNum">      16 </span>            :         we    : in  std_logic;                                 -- Write enable</a>
<a name="17"><span class="lineNum">      17 </span>            :         datao : out std_logic_vector (DATA_WIDTH-1 downto 0)   -- Output data</a>
<a name="18"><span class="lineNum">      18 </span>            :         );</a>
<a name="19"><span class="lineNum">      19 </span>            : end bram;</a>
<a name="20"><span class="lineNum">      20 </span>            : </a>
<a name="21"><span class="lineNum">      21 </span><span class="lineCov">          2 : architecture bram_arch of bram is</span></a>
<a name="22"><span class="lineNum">      22 </span>            : </a>
<a name="23"><span class="lineNum">      23 </span>            :   type ram_type is array ((2**ADDR_WIDTH)-1 downto 0) of std_logic_vector (DATA_WIDTH-1 downto 0);  -- Data type for memory contents</a>
<a name="24"><span class="lineNum">      24 </span><span class="lineCov">      86020 :   signal ram : ram_type;  -- Memory contents</span></a>
<a name="25"><span class="lineNum">      25 </span>            : </a>
<a name="26"><span class="lineNum">      26 </span>            : begin</a>
<a name="27"><span class="lineNum">      27 </span>            : </a>
<a name="28"><span class="lineNum">      28 </span>            :   -- When synthesizing this process, the synthesizer infers a BRAM </a>
<a name="29"><span class="lineNum">      29 </span><span class="lineCov">      86098 :   process(clk)</span></a>
<a name="30"><span class="lineNum">      30 </span>            :   begin</a>
<a name="31"><span class="lineNum">      31 </span><span class="lineCov">          6 :     if (rising_edge(clk)) then</span></a>
<a name="32"><span class="lineNum">      32 </span><span class="lineNoCov">          0 :       if (we = '1') then</span></a>
<a name="33"><span class="lineNum">      33 </span><span class="lineNoCov">          0 :         ram(to_integer(addri)) &lt;= datai;</span></a>
<a name="34"><span class="lineNum">      34 </span>            :       end if;</a>
<a name="35"><span class="lineNum">      35 </span><span class="lineCov">          8 :       datao &lt;= ram(to_integer(addri));</span></a>
<a name="36"><span class="lineNum">      36 </span>            :     end if;</a>
<a name="37"><span class="lineNum">      37 </span>            :   end process;</a>
<a name="38"><span class="lineNum">      38 </span>            : </a>
<a name="39"><span class="lineNum">      39 </span>            : end bram_arch;</a>
</pre>
      </td>
    </tr>
  </table>
  <br>

  <table width="100%" border=0 cellspacing=0 cellpadding=0>
    <tr><td class="ruler"><img src="../glass.png" width=3 height=3 alt=""></td></tr>
    <tr><td class="versionInfo">Generated by: <a href="http://ltp.sourceforge.net/coverage/lcov.php" target="_parent">LCOV version 1.14</a></td></tr>
  </table>
  <br>

</body>
</html>
